﻿using Infragistics.Web.UI.GridControls;
using Infragistics.Web.UI.ListControls;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class _Default : System.Web.UI.Page
{
   
    protected void Page_Load(object sender, EventArgs e)
    {
        if (Session["data"] == null)
        {
            Session["data"] = populateDataSet();
            whdg.DataSource = (DataSet)Session["data"];
            whdg.DataBind();
        }
        else
        {
            whdg.DataSource = (DataSet)Session["data"];
            whdg.DataBind();
        }

        wddUserNames.DataSource = UserNames();
        wddUserNames.DataBind();
      
    }

   

    private DataSet populateDataSet()
    {

        DataSet ds = new DataSet();
        DataTable Parent = new DataTable();
        Parent.TableName = "Parent";
        DataTable Child = new DataTable();
        Child.TableName = "Child";

        Parent.Columns.Add("ID", typeof(int));
        Parent.Columns.Add("Name");
        Parent.Columns.Add("CheckBox");

        DataColumn[] col = new DataColumn[1];
        col[0] = Parent.Columns["ID"];
        Parent.PrimaryKey = col;

        DataRow row;

        for (int i = 0; i < 10; i++)
        {
            row = Parent.NewRow();
            row.SetField<int>("ID", i);
            row.SetField<string>("Name", "Name " + i);
            Parent.Rows.Add(row);
        }

        Child.Columns.Add("ID", typeof(int));
        Child.Columns.Add("Address");
        Child.Columns.Add("Date");

        for (int j = 0; j < 10; j++)
        {
            row = Child.NewRow();
            row.SetField<int>("ID", j);
            row.SetField<string>("Address", "Address " + j);
            row.SetField<DateTime>("Date", DateTime.Today);
            Child.Rows.Add(row);
        }

        ds.Tables.Add(Parent);
        ds.Tables.Add(Child);

        ds.Relations.Add("IDRelation", Parent.Columns["ID"], Child.Columns["ID"]);

        return ds;
    }

    protected void Unnamed_ValueChanged(object sender, EventArgs e)
    {

    }

    protected void DropDownList1_SelectedIndexChanged(object sender, EventArgs e)
    {
        

        whdg.GridView.ClearDataSource();
       
        UnboundField unboundField1 = new UnboundField(true);
        unboundField1.Key = "TestColumn";
        unboundField1.Header.Text = "Test";
        this.whdg.GridView.Columns.Add(unboundField1);

        var wddProvider = new DropDownProvider()
        {
            ID = "wdd" + unboundField1.Header.Text
        };

        wddProvider.EditorControl.DataSource = populateDataSet().Tables[0];
        wddProvider.EditorControl.DataBind();
        wddProvider.EditorControl.DataKeyFields = "Name";
        wddProvider.EditorControl.ValueField = "Name";
        wddProvider.EditorControl.TextField = "Name";
        wddProvider.EditorControl.DisplayMode = DropDownDisplayMode.DropDownList;
        whdg.GridView.EditorProviders.Add(wddProvider);

        whdg.GridView.Behaviors.EditingCore.Behaviors.CellEditing.ColumnSettings.Add(new EditingColumnSetting(whdg.GridView)
        {
            ColumnKey = unboundField1.Key,
            EditorID = wddProvider.ID
        });

      

        whdg.DataSource = (DataSet)Session["data"];
        whdg.DataBind();
    }

    protected DataTable UserNames()
    {
        DataTable dt = new DataTable();
        dt.Columns.Add("Name");
        DataRow row;

        for (int i = 1; i < 21; i++)
        {
            row = dt.NewRow();
            row.SetField<string>("Name", "User Name" + i);
            dt.Rows.Add(row);
        }
        return dt;
    }
}